/* 
 * Acceleration- Receiver  NodeMCU ESP8266 Amica mit 3 Servos
 */

#include <Servo.h>   
#include <ESP8266WiFi.h>
#include <ESP8266WebServer.h>

Servo servoX; Servo servoY; Servo servoZ;
int posX = 90;  //10-170
int posY = 60;  //0-180
int posZ = 90;  //60-120

int posact = 90;
float posXsmoothed, posYsmoothed, posZsmoothed;
float posXold, posYold, posZold = 100;

const char *ssid = "ESP32 AP";
const char *password = "";

// Set your Static IP address
IPAddress local_IP(192, 168, 4, 13);
IPAddress gateway(192, 168, 4, 1);
IPAddress subnet(255, 255, 0, 0);
IPAddress primaryDNS(8, 8, 8, 8);   //optional
IPAddress secondaryDNS(8, 8, 4, 4); //optional

ESP8266WebServer server(80);



void handleSentVar1() {
  if (server.hasArg("sensor_1")) { // this is the variable sent from the client
    int readingInt1 = server.arg("sensor_1").toInt();

    posX = readingInt1;
   // make it smooth
    posXsmoothed = (posX*0.2) + (posXold * 0.8);
    posXold = posXsmoothed;
    servoX.write(posXsmoothed);
    Serial.print(" ax: ");Serial.print(readingInt1);
    server.send(200, "text/html","Data received");
  }
  delay(1);
}

 void handleSentVar3() {
  if (server.hasArg("sensor_3")) { // this is the variable sent from the client
    int readingInt3 = server.arg("sensor_3").toInt();

    posZ = readingInt3;
   // make it smooth
    posZsmoothed = (posZ*0.2) + (posZold * 0.8);
    posZold = posZsmoothed;
    posZsmoothed = posact + posZsmoothed;
    
    //servoY.write(posZsmoothed-50);
    servoY.write(readingInt3);
    posact = posZsmoothed;      // important to store new position
    Serial.print("           ay:  "); Serial.println(readingInt3);
    Serial.println("");
    //Serial.println(posZsmoothed);
    server.send(200, "text/html", "Data received");
  }
  delay(1);
 }
  
  void handleSentVar2() {
  if (server.hasArg("sensor_2")) { // this is the variable sent from the client
    int readingInt2 = server.arg("sensor_2").toInt();

    posY = readingInt2;
   // make it smooth
    posYsmoothed = (posY*0.2) + (posYold * 0.8);
    posYold = posYsmoothed;
    servoZ.write(posYsmoothed);
    Serial.print("    az:  ");Serial.print(readingInt2);
    server.send(200, "text/html", "Data received");
  }
  delay(1);
}



void setup() {

  Serial.begin(115200);
  delay(10);
  servoX.attach(13);
  servoY.attach(12);
  servoZ.attach(14);
  servoX.write(posX);   // set to mid position
  servoY.write(posY);
  servoZ.write(posZ);
  Serial.println(""); Serial.println("Servos set");
  
  delay(1500);

  //WiFi.mode(WIFI_STA);
  if (!WiFi.config(local_IP, gateway, subnet, primaryDNS, secondaryDNS)) {
    Serial.println("STA Failed to configure");
  }
  WiFi.begin(ssid, password);

  while (WiFi.status() != WL_CONNECTED) {
    delay(500);
  }
  Serial.println("Receiver connected to Wifi ...");
  
  server.on("/data1/", HTTP_GET, handleSentVar1); // when the server receives a request with /data/ in the string then run the handleSentVar function
  server.on("/data2/", HTTP_GET, handleSentVar2);
  server.on("/data3/", HTTP_GET, handleSentVar3);
  server.begin();
}


void loop() {
  server.handleClient();
}
